/******************************************************************************
*
* AntiMafia ActionSharing
* Copyright (C) 2002 by [epidemiC] AntiMafia
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
******************************************************************************/


// ActionSharingDummy.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#pragma warning(disable: 4786)
#include <map>
#include <string>
#include <algorithm>
#include "ActionSharingDummy.h"
using namespace std;

CRITICAL_SECTION g_criticalsection;
map<unsigned short, string> g_ids;

void Lock()
{
	EnterCriticalSection(&g_criticalsection);
}

void Unlock()
{
	LeaveCriticalSection(&g_criticalsection);
}


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			InitializeCriticalSection(&g_criticalsection);
			break;
		case DLL_PROCESS_DETACH:
			DeleteCriticalSection(&g_criticalsection);
			break;
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
			break;
    }
    return TRUE;
}

ACTIONSHARINGDUMMY_API BOOL Configure(const char *name, char *str, int len)
{
	::MessageBox(0, "Configuration() called", "ActionSharing Dummy", MB_SETFOREGROUND | MB_ICONINFORMATION | MB_OK);
	return TRUE;
}

ACTIONSHARINGDUMMY_API BOOL BeginAttack(unsigned short *id, const char *config, const char *target, unsigned short port)
{
	unsigned short& i = *id;
	char buf[1024];
	map<unsigned short, string>::iterator it;
	string s = string(target) + ":" + itoa(port, buf, 10);

	Lock();
	i = 0;
	do
	{
		++i;
		it = g_ids.find(i);
	} while(i < 100 && it != g_ids.end());
	if (i < 100)
		g_ids[i] = s;
	Unlock();
	if (i == 100)
		return FALSE;

	sprintf(buf, "BeginAttack() called for id = %hu\n%s", *id, s.c_str());
	::MessageBox(0, buf, "ActionSharing Dummy", MB_SETFOREGROUND | MB_ICONINFORMATION | MB_OK);
	return TRUE;
}

ACTIONSHARINGDUMMY_API BOOL Attack(unsigned short id)
{
	char buf[1024];
	string s;
	map<unsigned short int, string>::iterator it;
	Lock();
	it = g_ids.find(id);
	if (it != g_ids.end())
		s = it->second;
	Unlock();
	if (s.empty())
		return FALSE;

	sprintf(buf, "Attack() called for id = %hu\n%s", id, s.c_str());
	//::MessageBox(0, buf, "ActionSharing Dummy", MB_SETFOREGROUND | MB_ICONINFORMATION | MB_OK);
	::MessageBeep(MB_ICONASTERISK);
	Sleep(5000);
	return TRUE;
}

ACTIONSHARINGDUMMY_API BOOL EndAttack(unsigned short id)
{
	char buf[1024];
	string s;
	map<unsigned short int, string>::iterator it;
	Lock();
	it = g_ids.find(id);
	if (it != g_ids.end())
		s = it->second;
	Unlock();
	if (s.empty())
		return FALSE;

	sprintf(buf, "EndAttack() called for id = %hu\n%s", id, s.c_str());
	::MessageBox(0, buf, "ActionSharing Dummy", MB_SETFOREGROUND | MB_ICONINFORMATION | MB_OK);
	return TRUE;
}

